require 'xds_b.pnr.simpleapi'

local addElement = node.addElement
local setAttr = node.setAttr
local setInner = node.setInner

local PNR = require 'xds_b.pnr.model'
require 'example_xds_b_pnr_datamap'

function main(Data)
   --[[ 
   The current example does not use the inbound data as it hard codes everything.
   This will not be the case in a real scenario.  For example, the inbound data might 
   be an HL7 v2 message.  In this case, the message would be parsed using hl7.parse
   and fed into the helper functions for mapping.
   ]]
   
   FillAttachments(PNR)
   FillSubmissionSet(PNR)   
   FillDocumentEntries(PNR) 
   
   PNR.url = 'http://ihexds.nist.gov:12080/tf6/services/xdsrepositoryb'
   
   local HTTPHeaders, Body = xds_b.pnr.simpleapi.make(PNR)
   local Response, Status = net.http.post{
      url=PNR.url, 
      headers=HTTPHeaders, 
      body=Body, 
      live=true}
 
   return Status, xds_b.pnr.simpleapi.parseResponse{response=Response}
end

   