ihe.help = {}

function help.setShort(I)
   if not iguana.isTest() then return end    
   
   local LongHelp = {}
   local ShortHelp = I.info
   
   LongHelp.Title = ShortHelp.title
   LongHelp.Usage = ShortHelp.usage:gsub('<','&lt;'):gsub('>', '&gt;') 
   LongHelp.Desc = ShortHelp.description
   LongHelp.Returns = {}
   
   for i = 1, #ShortHelp.returns do 
      LongHelp.Returns[i] = {Desc=ShortHelp.returns[i]}
   end
   
   LongHelp.ParameterTable = true
   for i=1, #ShortHelp.examples do 
      LongHelp.Examples[i] = ShortHelp.examples[i]
   end
   
   trace(LongHelp)
   trace(addCodeHelp)
end

local helpSetHelp = {
   title="ihe.help.set",
   usage="ihe.help.set{func=<function>, info=<lua table with help>}",
   description=[[This function will set up the help for a function using this simplified help format.]],
   returns={"Nothing"},
   parameters={
      func='The function to set the help for.', 
      info='The help information formatted in a Lua table',
   },
   examples={[[ihe.help.set{func=xds_b.help.set, info=xds_bHelpSet}]]}
}

function ihe.help.set(I)
   if not iguana.isTest() then return end 
   
   local LongHelp = {}
   local ShortHelp = I.info
   LongHelp.Returns = {}
   LongHelp.Title = ShortHelp.title
   LongHelp.Usage = ShortHelp.usage:gsub('<','&lt;'):gsub('>', '&gt;') 
   LongHelp.Desc = ShortHelp.description
   
   for i = 1, #ShortHelp.returns do 
      LongHelp.Returns[i] = {Desc=ShortHelp.returns[i]}
   end
   
   LongHelp.ParameterTable = true
   LongHelp.Examples = {}
   
   for i=1, #ShortHelp.examples do 
      LongHelp.Examples[i] = ShortHelp.examples[i]
   end
   
   LongHelp.Parameters = {}
   local i = 1
   for K,V in pairs(ShortHelp.parameters) do 
      LongHelp.Parameters[i] = {}
      LongHelp.Parameters[i][K] = {Desc=V}
      i = i + 1
   end
   
   if ShortHelp.optional_parameters then
      for K,V in pairs(ShortHelp.optional_parameters) do 
         LongHelp.Parameters[i] = {}
         LongHelp.Parameters[i][K] = {Desc=V, Opt=true}
         i = i + 1
      end
   end
   
   help.set{input_function=I.func, help_data=LongHelp}
end

ihe.help.set{func=ihe.help.set, info=helpSetHelp}

function ihe.help.check(I, H)
   local Expected = H.parameters
   local Optional = H.optional_parameters or {}
   for K,V in pairs(I) do
      if Expected[K] == nil and Optional[K] == nil then
         error(K..' entry is not expected',3)
      end
   end
   for K,V in pairs(Expected) do
      if I[K] == nil then
         error('Expected required parameter '..K, 3)
      end
   end
end

-- This means in production we don't check parameters
if not iguana.isTest() then ihe.help.check=function(I,H) end end